<?php

/**
 * inf_causa_vacac actions.
 *
 * @package    nomina
 * @subpackage inf_causa_vacac
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_causa_vacacActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by id_ea, id_cen_op, num_doc, fecha_ini';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];
            $id_meses = $request['id_meses'];
            $id_anhos = $request['id_anhos'];
            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //Area
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }
            //cenop
            if (isset($request['id_cen_op'])) {
                $whereCenOp = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOp = ' ';
            }
            //retiro
            if (isset($request['retiro']) && $request['retiro'] != 'false') {
                if ($request['retiro'] == 'true') {
                    $whereRetiro = " AND tab0.retiro = 1 ";
                } else {
                    $whereRetiro = " AND tab0.retiro = 0 ";
                }
            } else {
                $whereRetiro = ' ';
            }
            /*
             * Filtro dias sin pendientes en los periodos causados - 20140730
             * tag_dia
             */
            if (isset($request['tag_dia'])) {
                $tag_dia = $request['tag_dia'];
            } else {
                $tag_dia = 0;
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             * Se actualiza consulta segun jasper, por nuevos campos de estado y relaciones al nombramiento - 20220217::LAVILA
             */
            $sql = <<<EOD
select count(*) as count from (

select
tab0.*
from (

    select
    tab.*,
    tab1.nombre_apellido,
    tab3.nom_encarga,
    tab3.email_enc,
    tab3.id_nat_em,
    tab3.id_comp_es,
    tab3.id_nat_emp,
    tab3.CODIGO_NAT,
    tab3.naturaleza,
    tab3.COMPONENTE,
    tab3.asignacion_basica,
    tab3.id_dp,
    tab3.id_mf,
    tab3.id_ea,
    tab3.nombre_inst,
    tab3.codigo,
    tab3.titular,
    tab3.encargado,
    tab3.id_den_emp,
    tab3.id_sa_nom_tit,
    tab3.id_sa_nom_enc,
    tab3.id_cia,
    tab3.id_cen_op,
    nvl(tab3.centro, 'Sin Especificar Centro') as centro,
    nvl(tab3.area, 'Sin Especificar Area') as area,
    tab3.num_doc_tit,
    tab3.primer_apellido_tit,
    tab3.segundo_apellido_tit,
    tab3.primer_nombre_tit,
    tab3.segundo_nombre_tit,
    tab3.nombre_apellido_tit,
    tab3.nom_titular,
    tab3.email_tit,
    tab3.num_doc_enc,
    tab3.primer_apellido_enc,
    tab3.segundo_apellido_enc,
    tab3.primer_nombre_enc,
    tab3.SEGUNDO_NOMBRE_ENC,
    tab3.nombre_apellido_enc,

    case when nvl(tab5.actual,tab4.estado) = 1 then 0 else 1 end as retiro,
    case when tab4.estado = 1 then 0 else 1 end as retiro_nom,
    tab4.fecha_ingreso,
    tab4.fecha_termina,
    tab4.fecha_retiro

    from no_causa_vacac tab

    left join no_datos_funcionario_v tab1 on tab1.id_tipo_doc = tab.id_tipo_doc and tab1.num_doc = tab.num_doc

    --left join no_estado_func_v tab2 ON tab2.id_tipo_doc = tab.id_tipo_doc and tab2.num_doc = tab.num_doc
    left join (
      SELECT
       aut.*,
       ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.id_anhos DESC, aut.id_meses DESC, aut.periodo DESC
       ) AS rn_aut
      from no_estado_func_v aut
    )tab2
    on tab2.id_tipo_doc = tab.id_tipo_doc 
    and tab2.num_doc = tab.num_doc
    and tab2.rn_aut = 1

    left join no_dp_v tab3 ON tab3.id_dp = tab2.id_dp

    --left join no_nombramiento_v tab4 ON tab4.id_tipo_doc = tab.id_tipo_doc  and tab4.num_doc = tab.num_doc
    left join no_nombramiento tab4 ON tab4.id_tipo_doc = tab.id_tipo_doc  and tab4.num_doc = tab.num_doc and tab.fecha_ini BETWEEN tab4.fecha_ingreso and nvl(tab4.fecha_termina,sysdate)

    left join no_periodo per
    on per.id_tipo_periodo = 1 and per.id_anhos = $id_anhos and per.id_meses = $id_meses

    left join no_estado_func_v tab5 on tab5.id_tipo_doc = tab.id_tipo_doc  and tab5.num_doc = tab.num_doc
    and tab5.periodo = per.id_periodo

        where
    (tab.saldos_dias > 0 or 1 = $tag_dia )
    and tab.fecha_fin <= last_day(to_date( $id_meses||'-'||$id_anhos ,'MM-YYYY'))
    --and tab2.actual = 1
    --and tab2.periodo = $periodo
    --and tab4.fecha_termina <= last_day(to_date( $id_meses||'-'||$id_anhos ,'MM-YYYY'))

)tab0
where
1 = 1
$whereArea
$whereCenOp
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereRetiro 

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select
tab0.*
from (

    select
    tab.*,
    tab1.nombre_apellido,
    tab3.nom_encarga,
    tab3.email_enc,
    tab3.id_nat_em,
    tab3.id_comp_es,
    tab3.id_nat_emp,
    tab3.CODIGO_NAT,
    tab3.naturaleza,
    tab3.COMPONENTE,
    tab3.asignacion_basica,
    tab3.id_dp,
    tab3.id_mf,
    tab3.id_ea,
    tab3.nombre_inst,
    tab3.codigo,
    tab3.titular,
    tab3.encargado,
    tab3.id_den_emp,
    tab3.id_sa_nom_tit,
    tab3.id_sa_nom_enc,
    tab3.id_cia,
    tab3.id_cen_op,
    nvl(tab3.centro, 'Sin Especificar Centro') as centro,
    nvl(tab3.area, 'Sin Especificar Area') as area,
    tab3.num_doc_tit,
    tab3.primer_apellido_tit,
    tab3.segundo_apellido_tit,
    tab3.primer_nombre_tit,
    tab3.segundo_nombre_tit,
    tab3.nombre_apellido_tit,
    tab3.nom_titular,
    tab3.email_tit,
    tab3.num_doc_enc,
    tab3.primer_apellido_enc,
    tab3.segundo_apellido_enc,
    tab3.primer_nombre_enc,
    tab3.SEGUNDO_NOMBRE_ENC,
    tab3.nombre_apellido_enc,

    case when nvl(tab5.actual,tab4.estado) = 1 then 0 else 1 end as retiro,
    case when tab4.estado = 1 then 0 else 1 end as retiro_nom,
    tab4.fecha_ingreso,
    tab4.fecha_termina,
    tab4.fecha_retiro

    from no_causa_vacac tab

    left join no_datos_funcionario_v tab1 on tab1.id_tipo_doc = tab.id_tipo_doc and tab1.num_doc = tab.num_doc

    --left join no_estado_func_v tab2 ON tab2.id_tipo_doc = tab.id_tipo_doc and tab2.num_doc = tab.num_doc
    left join (
      SELECT
       aut.*,
       ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.id_anhos DESC, aut.id_meses DESC, aut.periodo DESC
       ) AS rn_aut
      from no_estado_func_v aut
    )tab2
    on tab2.id_tipo_doc = tab.id_tipo_doc 
    and tab2.num_doc = tab.num_doc
    and tab2.rn_aut = 1

    left join no_dp_v tab3 ON tab3.id_dp = tab2.id_dp

    --left join no_nombramiento_v tab4 ON tab4.id_tipo_doc = tab.id_tipo_doc  and tab4.num_doc = tab.num_doc
    left join no_nombramiento tab4 ON tab4.id_tipo_doc = tab.id_tipo_doc  and tab4.num_doc = tab.num_doc and tab.fecha_ini BETWEEN tab4.fecha_ingreso and nvl(tab4.fecha_termina,sysdate)

    left join no_periodo per
    on per.id_tipo_periodo = 1 and per.id_anhos = $id_anhos and per.id_meses = $id_meses

    left join no_estado_func_v tab5 on tab5.id_tipo_doc = tab.id_tipo_doc  and tab5.num_doc = tab.num_doc
    and tab5.periodo = per.id_periodo

        where
    (tab.saldos_dias > 0 or 1 = $tag_dia )
    and tab.fecha_fin <= last_day(to_date( $id_meses||'-'||$id_anhos ,'MM-YYYY'))
    --and tab2.actual = 1
    --and tab2.periodo = $periodo
    --and tab4.fecha_termina <= last_day(to_date( $id_meses||'-'||$id_anhos ,'MM-YYYY'))

)tab0
where
1 = 1
$whereArea
$whereCenOp
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereRetiro 
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_causa_vacac] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
